Index: /java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 98)
@@ -17,5 +17,4 @@
 import org.apache.log4j.Logger;
 
-import com.framsticks.params.Flags;
 import com.framsticks.params.types.DecimalParam;
 import com.framsticks.params.types.FloatParam;
@@ -55,5 +54,4 @@
 		slider = new JSlider();
 
-		slider.setEnabled(!isReadOnly());
 		slider.setPaintLabels(false);
 		if (param instanceof DecimalParam) {
@@ -110,5 +108,4 @@
 		text.setHorizontalAlignment(JSlider.CENTER);
 
-		text.setEnabled(!param.hasFlag(Flags.READONLY));
 
 		slider.addChangeListener(new ChangeListener() {
@@ -206,3 +203,9 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		slider.setEnabled(enabled);
+		text.setEnabled(enabled);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 98)
@@ -18,5 +18,4 @@
 		textArea.setLineWrap(true);
 		textArea.setWrapStyleWord(true);
-		textArea.setEditable(!isReadOnly());
 		addDefaultDocumentListener(textArea);
 
@@ -47,3 +46,8 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		textArea.setEditable(enabled);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 98)
@@ -31,6 +31,4 @@
 		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
 
-		textField.setEditable(!isReadOnly());
-
 		addDefaultDocumentListener(textField);
 
@@ -48,3 +46,8 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		textField.setEnabled(enabled);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 98)
@@ -97,9 +97,4 @@
 	}
 
-	public final boolean isReadOnly() {
-		return (param.getFlags() & Flags.READONLY) != 0;
-	}
-
-
 
 }
Index: /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 98)
@@ -1,13 +1,12 @@
 package com.framsticks.gui.view;
 
-import com.framsticks.gui.ImageProvider;
-import com.framsticks.gui.TreeNode;
+import java.awt.Component;
 
-import javax.swing.*;
+import javax.swing.JTree;
 import javax.swing.tree.DefaultTreeCellRenderer;
 
-import org.apache.log4j.Logger;
-
-import java.awt.*;
+import com.framsticks.gui.AbstractNode;
+import com.framsticks.gui.ImageProvider;
+import com.framsticks.params.CompositeParam;
 
 /**
@@ -16,12 +15,10 @@
 @SuppressWarnings("serial")
 public class TreeCellRenderer extends DefaultTreeCellRenderer {
-	private static final Logger log =
-		Logger.getLogger(TreeCellRenderer.class);
-
 
 	public TreeCellRenderer() {
-		setOpenIcon(null);
-		setClosedIcon(null);
-		setLeafIcon(null);
+
+		// setOpenIcon(ImageProvider.loadImage(ImageProvider.FOLDER_OPEN));
+		// setClosedIcon(ImageProvider.loadImage(ImageProvider.FOLDER_CLOSED));
+		// setLeafIcon(ImageProvider.loadImage(ImageProvider.NODE));
 	}
 
@@ -31,121 +28,69 @@
 			boolean hasFocus) {
 
-		//super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
-		//		row, hasFocus);
+		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
+
 		if (value == null) {
+			setText("!null value");
 			return this;
 		}
-		if (!(value instanceof TreeNode)) {
+
+		if (!(value instanceof AbstractNode)) {
 			setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
 			setText("framsticks");
 			return this;
 		}
-		TreeNode treeNode = (TreeNode)value;
-		assert treeNode.getFrame().isActive();
-		setToolTipText(treeNode.getTooltip());
-		setIcon(ImageProvider.loadImage(treeNode.getIconName()));
-		setText(treeNode.getName());
+		((AbstractNode) value).render(this);
+
 		return this;
 	}
 
-	public static String findIconName(String nodeName, String path) {
-		if (nodeName == null || path == null) {
-			log.warn("given invalid parameters: " + nodeName + " " + path);
-			// return null;
-			return ImageProvider.SERVER;
+	public static String findIconName(CompositeParam param) {
+		switch (param.getFramsTypeName()) {
+			case "o Server": return ImageProvider.SERVER;
+			case "o Simulator": return ImageProvider.SIMULATOR;
+			case "o CLI": return ImageProvider.CLI;
+			case "o World": return ImageProvider.WORLD;
+			case "o GenePools": return ImageProvider.GENEPOOLS;
+			case "l GenePool": return ImageProvider.SIMULATOR; //HERE
+			case "o GenePool": return ImageProvider.GENEPOOLS_GROUP; //HERE
+
+			case "o Populations": return ImageProvider.POPULATIONS;
+			case "l Population": return ImageProvider.SIMULATOR; ///HERE
+			case "o Population": return ImageProvider.POPULATION_GROUP;
+			case "o ExpParams": return ImageProvider.EXPERIMENT;
+			case "o stats": return ImageProvider.STATISTIC;
+			case "l Genotype uid": return ImageProvider.GENOTYPES_GROUP;
+			case "o Genotype": return ImageProvider.GENOTYPES;
+
+			case "o Part": return ImageProvider.PART;
+			case "o Joint": return ImageProvider.JOINT;
+			case "o NeuroDef": return ImageProvider.NEURON_DEF;
+			case "o NeuroConn": return ImageProvider.NEURON_DEF;
+
+			case "o MechPart": return ImageProvider.MECH_PART;
+			case "o MechJoint": return ImageProvider.MECH_JOINT;
+			case "o Neuro": return ImageProvider.NEURON;
+
+			case "l Part": return ImageProvider.PART_GROUP;
+			case "l Joint": return ImageProvider.JOINT_GROUP;
+			case "l NeuroDef": return ImageProvider.NEURON_DEF_GROUP;
+			case "l NeuroConn": return ImageProvider.NEURON_DEF_GROUP;
+
+			case "l MechPart": return ImageProvider.MECH_PART_GROUP;
+			case "l MechJoint": return ImageProvider.MECH_JOINT_GROUP;
+			case "l Neuro": return ImageProvider.NEURON_GROUP;
+
+			case "o Creature": return ImageProvider.CREATURE;
+			case "l Creature uid": return ImageProvider.CREATURES_GROUP;
+			case "l Event id": return ImageProvider.EVENT;
+			case "o Event": return ImageProvider.EVENT;
+
 		}
-		if (path.equals("/")) {
-			return ImageProvider.SERVER;
-		}
-		if (path.endsWith("simulator")) {
-			return ImageProvider.SIMULATOR;
-		}
-		if (path.endsWith("cli")) {
-			return ImageProvider.CLI;
-		}
-		if (path.endsWith("world")) {
-			return ImageProvider.WORLD;
-		}
-		if (path.endsWith("genepools")) {
-			return ImageProvider.GENEPOOLS;
-		}
-		if (path.endsWith("populations")) {
-			return ImageProvider.POPULATIONS;
-		}
-		if (path.endsWith("experiment")) {
-			return ImageProvider.EXPERIMENT;
-		}
-		if (path.endsWith("stats")) {
-			return ImageProvider.STATISTIC;
-		}
-		if (nodeName.equals("creatures") || path.endsWith("creatures")) {
-			return ImageProvider.CREATURES_GROUP;
-		}
-		if (nodeName.equals("Favourite Fields")) {
-			return ImageProvider.FAVORITE_FIELDS;
-		}
-		if (nodeName.equals("genotypes") || path.endsWith("creatures")) {
-			return ImageProvider.GENOTYPES_GROUP;
-		}
-		if (nodeName.equals("parts") || path.endsWith("parts")) {
-			return ImageProvider.PART_GROUP;
-		}
-		if (nodeName.equals("joints") || path.endsWith("joints")) {
-			return ImageProvider.JOINT_GROUP;
-		}
-		if (nodeName.equals("neurodefs") || path.endsWith("neurodefs")) {
-			return ImageProvider.NEURON_DEF_GROUP;
-		}
-		if (nodeName.equals("neuroconns") || path.endsWith("neuroconns")) {
-			return ImageProvider.NEURON_DEF_GROUP;
-		}
-		if (nodeName.equals("mechparts") || path.endsWith("mechparts")) {
-			return ImageProvider.MECH_PART_GROUP;
-		}
-		if (nodeName.equals("mechjoints") || path.endsWith("mechjoints")) {
-			return ImageProvider.MECH_JOINT_GROUP;
-		}
-		if (nodeName.equals("neurons") || path.endsWith("neurons")) {
-			return ImageProvider.NEURON_GROUP;
-		}
-		if (path.matches("^.*parts/[0-9]+$")) {
-			return ImageProvider.PART;
-		}
-		if (path.matches("^.*joints/[0-9]+$")) {
-			return ImageProvider.JOINT;
-		}
-		if (path.matches("^.*neurodefs/[0-9]+$")) {
-			return ImageProvider.NEURON_DEF;
-		}
-		if (path.matches("^.*neuroconns/[0-9]+$")) {
-			return ImageProvider.NEURON_DEF;
-		}
-		if (path.matches("^.*mechparts/[0-9]+$")) {
-			return ImageProvider.MECH_PART;
-		}
-		if (path.matches("^.*mechjoints/[0-9]+$")) {
-			return ImageProvider.MECH_JOINT;
-		}
-		if (path.matches("^.*neurons/[0-9]+$")) {
-			return ImageProvider.NEURON;
-		}
-		if (path.matches("^.*creatures/c[0-9]+$")) {
-			return ImageProvider.CREATURE;
-		}
-		if (path.matches("^.*genotypes/g[0-9]+$")) {
-			return ImageProvider.GENOTYPES;
-		}
-		if (path.matches("^.*populations/groups/[0-9]+$")) {
-			return ImageProvider.POPULATION_GROUP;
-		}
-		if (path.matches("^.*genepools/groups/[0-9]+$")) {
-			return ImageProvider.GENEPOOLS_GROUP;
-		}
-		if (path.matches("^.*events/e[0-9]+$")) {
-			return ImageProvider.EVENT;
-		}
-		return ImageProvider.SIMULATOR;
+
+
+		return ImageProvider.SERVER;
 	}
 
 
+
 }
Index: /java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 98)
@@ -9,5 +9,4 @@
 import com.framsticks.communication.queries.InfoRequest;
 import com.framsticks.communication.queries.SetRequest;
-import com.framsticks.core.Mode;
 import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
@@ -18,4 +17,5 @@
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
@@ -31,5 +31,5 @@
  * @author Piotr Sniegowski
  */
-public class ClientAtServer extends AbstractJoinable implements RequestHandler, JoinableParent {
+public class ClientAtServer extends AbstractJoinable implements RequestHandler, JoinableParent, ExceptionResultHandler {
 
 	protected final Server server;
@@ -52,7 +52,11 @@
 		assureNotEmpty(request.getPath());
 
-		resolve(tree, request.getPath(), new FutureHandler<Path>(responseCallback) {
+		tryGet(tree, request.getPath(), new FutureHandler<Path>(responseCallback) {
 			@Override
 			protected void result(final Path path) {
+
+				if (!path.getTextual().equals(request.getPath())) {
+					throw new FramsticksException().msg("invalid path").arg("path", request.getPath());
+				}
 
 				// final AccessInterface access = tree.prepareAccess(path);
@@ -73,19 +77,13 @@
 
 				if (request instanceof GetRequest) {
-					tree.get(path, Mode.FETCH, new FutureHandler<Object>(responseCallback) {
-
-						@Override
-						protected void result(Object result) {
-							if (result != access.getSelected()) {
-								throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
-							}
-							// TODO Auto-generated method stub
-							List<File> files = new LinkedList<File>();
-							ListSink sink = new ListSink();
-							access.save(sink);
-							files.add(new File(path.getTextual(), new ListSource(sink.getOut())));
-							responseCallback.pass(new Response(true, "", files));
-						}
-					});
+					Object result = path.getTopObject();
+					if (result != access.getSelected()) {
+						throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
+					}
+					List<File> files = new LinkedList<File>();
+					ListSink sink = new ListSink();
+					access.save(sink);
+					files.add(new File(path.getTextual(), new ListSource(sink.getOut())));
+					responseCallback.pass(new Response(true, "", files));
 
 					return;
@@ -148,4 +146,8 @@
 	}
 
+	@Override
+	public void handle(FramsticksException exception) {
+		tree.handle(exception);
+	}
 
 }
Index: /java/main/src/main/java/com/framsticks/hosting/Server.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/hosting/Server.java	(revision 98)
@@ -124,6 +124,5 @@
 			return;
 		}
-		//TODO TEH
-		acceptThread.dispatch(new RunAt<Accept>(ThrowExceptionHandler.getInstance()) {
+		acceptThread.dispatch(new RunAt<Accept>(hosted) {
 			@Override
 			protected void runAt() {
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 98)
@@ -1,5 +1,4 @@
 package com.framsticks.params;
 
-import java.util.Collection;
 
 import com.framsticks.params.types.ProcedureParam;
@@ -71,5 +70,5 @@
 	Object createAccessee();
 
-	Collection<Param> getParams();
+	Iterable<Param> getParams();
 
 	FramsClass getFramsClass();
@@ -77,4 +76,8 @@
 	void tryAutoAppend(Object object);
 
+	int getCompositeParamCount();
+
+	CompositeParam getCompositeParam(int number);
+
 
 }
Index: /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 98)
@@ -1,10 +1,11 @@
 package com.framsticks.params;
 
+import com.framsticks.util.UnimplementedException;
 import com.framsticks.util.lang.Numbers;
 
 import java.util.ArrayList;
-import java.util.Collection;
-import java.util.LinkedList;
+import java.util.Iterator;
 import java.util.List;
+import java.util.ListIterator;
 
 /**
@@ -30,11 +31,13 @@
 
 	@Override
-	public Param getParam(int i) {
-		//TODO listAccessParam
-		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish();
+	public CompositeParam getParam(int i) {
+		if ((i < 0) ||  (i >= list.size())) {
+			return null;
+		}
+		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish(CompositeParam.class);
 	}
 
 	@Override
-	public Param getParam(String id) {
+	public CompositeParam getParam(String id) {
 		Integer i = Numbers.parse(id, Integer.class);
 		return (i == null ? null : getParam(i));
@@ -53,8 +56,8 @@
 	@Override
 	public <T> T get(int i, Class<T> type) {
-		if (i < list.size()) {
-			return type.cast(list.get(i));
+		if ((i < 0) ||  (i >= list.size())) {
+			return null;
 		}
-		return null;
+		return type.cast(list.get(i));
 	}
 
@@ -112,13 +115,43 @@
 
 	@Override
-	public Collection<Param> getParams() {
-		List<Param> result = new LinkedList<Param>();
-		if (list == null) {
-			return result;
-		}
-		for (int i = 0; i < list.size(); ++i) {
-			result.add(getParam(i));
-		}
-		return result;
+	public Iterable<Param> getParams() {
+		return new Iterable<Param>() {
+
+			@Override
+			public Iterator<Param> iterator() {
+				return new Iterator<Param>() {
+
+					protected ListIterator<Object> internal = list.listIterator();
+
+					@Override
+					public boolean hasNext() {
+						return internal.hasNext();
+					}
+
+					@Override
+					public Param next() {
+						Param param = Param.build().id(Integer.toString(internal.nextIndex())).forAccess(elementAccess).finish();
+						internal.next();
+						return param;
+					}
+
+					@Override
+					public void remove() {
+						throw new UnimplementedException().msg("remove element from list").arg("list", ArrayListAccess.this);
+
+					}
+				};
+			}
+		};
+	}
+
+	@Override
+	public int getCompositeParamCount() {
+		return list.size();
+	}
+
+	@Override
+	public CompositeParam getCompositeParam(int number) {
+		return getParam(number);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/CompositeParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 98)
@@ -36,3 +36,8 @@
 	}
 
+	@Override
+	public String toString() {
+		return getId() + ":" + this.getClass().getSimpleName() + "(" + containedTypeName + ")";
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 98)
@@ -43,12 +43,12 @@
 	protected final List<Param> paramList;
 
+	protected final List<CompositeParam> compositeParamList = new ArrayList<>();
+
 	/**
 	 * The param entry map <parameterId, param> (for fast accessing of parameters
 	 * by their name)
 	 */
-	protected Map<String, Param> paramEntryMap = new LinkedHashMap<String, Param>();
-
-	// /** The param getId map (for fast lookup of offset based on name */
-	// protected Map<String, Integer> paramIdMap = new HashMap<String, Integer>();
+	protected Map<String, Param> paramEntryMap = new HashMap<>();
+
 
 	@ParamAnnotation(id = "props", name = "props")
@@ -67,4 +67,7 @@
 		for (Param param : paramList) {
 			paramEntryMap.put(param.getId(), param);
+			if (param instanceof CompositeParam) {
+				compositeParamList.add((CompositeParam) param);
+			}
 		}
 
@@ -182,4 +185,12 @@
 	}
 
+	public final int getCompositeParamCount() {
+		return compositeParamList.size();
+	}
+
+	public final CompositeParam getCompositeParam(int i) {
+		return compositeParamList.get(i);
+	}
+
 	@Override
 	public String toString() {
@@ -190,3 +201,4 @@
 		return new FramsClassBuilder();
 	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 98)
@@ -9,5 +9,5 @@
 import java.util.ArrayList;
 import java.util.Collections;
-import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.LinkedList;
 import java.util.List;
@@ -197,5 +197,5 @@
 	}
 
-	public static final Map<Class<?>, FramsClass> synchronizedCacheForBasedOnForJavaClass = Collections.synchronizedMap(new HashMap<Class<?>, FramsClass>());
+	public static final Map<Class<?>, FramsClass> synchronizedCacheForBasedOnForJavaClass = Collections.synchronizedMap(new IdentityHashMap<Class<?>, FramsClass>());
 
 	public FramsClass forClass(Class<?> javaClass) throws ConstructionException {
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 98)
@@ -8,4 +8,5 @@
 import java.util.Comparator;
 import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.List;
 import java.util.Map;
@@ -56,7 +57,7 @@
 		}
 
-		protected final Map<ValueParam, ReflectedSetter> setters = new HashMap<>();
-		protected final Map<ValueParam, ReflectedGetter> getters = new HashMap<>();
-		protected final Map<ProcedureParam, ReflectedCaller> callers = new HashMap<>();
+		protected final Map<ValueParam, ReflectedSetter> setters = new IdentityHashMap<>();
+		protected final Map<ValueParam, ReflectedGetter> getters = new IdentityHashMap<>();
+		protected final Map<ProcedureParam, ReflectedCaller> callers = new IdentityHashMap<>();
 		protected final List<Method> autoAppendMethods = new ArrayList<>();
 
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 98)
@@ -7,6 +7,7 @@
 import com.framsticks.util.DoubleMap;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Strings;
 
-import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.Map;
 import java.util.Set;
@@ -23,5 +24,5 @@
 	protected final DoubleMap<String, Class<?>> javaClasses = new DoubleMap<>();
 	protected final DoubleMap<String, FramsClass> framsClasses = new DoubleMap<>();
-	protected final Map<Class<?>, FramsClass> javaToFramsAssociation = new HashMap<>();
+	protected final Map<Class<?>, FramsClass> javaToFramsAssociation = new IdentityHashMap<>();
 
 	/**
@@ -108,4 +109,5 @@
 	public @Nonnull AccessInterface createAccess(@Nonnull String name) throws ConstructionException {
 		try {
+			Strings.assureNotEmpty(name);
 			FramsClass framsClass = getFramsClass(name);
 			if (framsClass == null) {
Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 98)
@@ -1,5 +1,4 @@
 package com.framsticks.params;
 
-import java.util.Collection;
 
 import static com.framsticks.util.lang.Containers.filterInstanceof;
@@ -113,5 +112,5 @@
 			ReassignResult<?> result = param.reassign(value, oldValue);
 			Object casted = result.getValue();
-			if (!casted.equals(oldValue)) {
+			if (casted != null && !casted.equals(oldValue)) {
 				internalSet(param, casted);
 			}
@@ -273,6 +272,16 @@
 
 	@Override
-	public Collection<Param> getParams() {
+	public Iterable<Param> getParams() {
 		return framsClass.getParamEntries();
+	}
+
+	@Override
+	public int getCompositeParamCount() {
+		return framsClass.getCompositeParamCount();
+	}
+
+	@Override
+	public CompositeParam getCompositeParam(int number) {
+		return framsClass.getCompositeParam(number);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 98)
@@ -1,4 +1,7 @@
 package com.framsticks.params;
 
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.UnimplementedException;
+import com.framsticks.util.UnsupportedOperationException;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
@@ -12,5 +15,5 @@
 public class UniqueListAccess extends ListAccess {
 
-	private static final Logger log = Logger.getLogger(UniqueListAccess.class.getName());
+	private static final Logger log = Logger.getLogger(UniqueListAccess.class);
 
 	Map<String, Object> map;
@@ -23,27 +26,75 @@
 	}
 
+	public static Integer getUidNumber(String uid) {
+		try {
+			return Integer.valueOf(uid.substring(1));
+		} catch (NumberFormatException e) {
+			return null;
+		}
+	}
+
+	public static class UidComparator implements Comparator<String> {
+
+		protected String name;
+
+		/**
+		 * @param name
+		 */
+		public UidComparator(String name) {
+			this.name = name;
+		}
+
+		@Override
+		public int compare(String a, String b) {
+			if (a.equals(b)) {
+				return 0;
+			}
+			int diff = a.length() - b.length();
+			if (diff != 0) {
+				return diff;
+			}
+			Integer au = getUidNumber(a);
+			Integer bu = getUidNumber(b);
+			if (au == null || bu == null) {
+				throw new FramsticksException().msg("comparator failure").arg("left", a).arg("right", b).arg("in", this);
+			}
+			return au - bu;
+		}
+
+		@Override
+		public String toString() {
+			return "comparator " + name;
+		}
+
+
+	}
+
 	@Override
 	public Map<String, Object> createAccessee() {
-		return new HashMap<String, Object>();
-	}
-
-	@Override
-	public Param getParam(int i) {
-		log.error("accesing unique list through index");
-		assert false;
-		return null;
-		//log.error("accesing unique list through index");
-		//return null;
-		//return Param.build().setId(Integer.toString(i)).setName(elementAccess.getId()).type("o " + elementAccess.getId()).build();
-	}
-
-	@Override
-	public Param getParam(String id) {
+		return new TreeMap<String, Object>(new UidComparator(elementAccess.toString()));
+	}
+
+	@Override
+	public CompositeParam getParam(int i) {
+		if ((i < 0) ||  (i >= map.size())) {
+			return null;
+		}
+		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish(CompositeParam.class);
+	}
+
+	@Override
+	public CompositeParam getParam(String id) {
 		Integer i = Numbers.parse(id, Integer.class);
 		if (i != null) {
 			return getParam(i);
 		}
-		//TODO list access here
-		return Param.build().id(id).forAccess(elementAccess).finish();
+		Integer uidNumber = getUidNumber(id);
+		if (uidNumber == null) {
+			return null;
+		}
+		if (!map.containsKey(id)) {
+			return null;
+		}
+		return Param.build().id(id).forAccess(elementAccess).finish(CompositeParam.class);
 	}
 
@@ -60,9 +111,16 @@
 	@Override
 	public <T> T get(int i, Class<T> type) {
-		log.error("accesing unique list through index");
-		assert false;
-		return null;
-		//Object[] values = map.values().toArray();
-		//return Casting.tryCast(i < values.length ? values[i] : null, type);
+		Iterator<Map.Entry<String, Object>> iterator = map.entrySet().iterator();
+		while (i > 0 && iterator.hasNext()) {
+			iterator.next();
+			--i;
+		}
+		if (i > 0) {
+			return null;
+		}
+		if (!iterator.hasNext()) {
+			return null;
+		}
+		return Casting.tryCast(type, iterator.next().getValue());
 	}
 
@@ -73,5 +131,9 @@
 			return get(i, type);
 		}
-		return Casting.tryCast(type, map.containsKey(id) ? map.get(id) : null);
+		Integer uidNumber = getUidNumber(id);
+		if (uidNumber == null) {
+			return null;
+		}
+		return Casting.tryCast(type, map.get(id));
 	}
 
@@ -110,7 +172,5 @@
 	@Override
 	public <T> int set(int i, T value) {
-		log.error("accesing unique list through index");
-		//return setByUid(value, null);
-		return 0;
+		throw new UnsupportedOperationException().msg("accesing unique list through index");
 	}
 
@@ -184,13 +244,41 @@
 
 	@Override
-	public Collection<Param> getParams() {
-		List<Param> result = new LinkedList<Param>();
-		if (map == null) {
-			return result;
-		}
-		for (String k : map.keySet()) {
-			result.add(getParam(k));
-		}
-		return result;
+	public Iterable<Param> getParams() {
+		return new Iterable<Param>() {
+
+			@Override
+			public Iterator<Param> iterator() {
+				return new Iterator<Param>() {
+
+					protected Iterator<Map.Entry<String, Object>> internal = map.entrySet().iterator();
+
+					@Override
+					public boolean hasNext() {
+						return internal.hasNext();
+					}
+
+					@Override
+					public Param next() {
+						return Param.build().id(internal.next().getKey()).forAccess(elementAccess).finish();
+					}
+
+					@Override
+					public void remove() {
+						throw new UnimplementedException().msg("remove element from list").arg("list", UniqueListAccess.this);
+
+					}
+				};
+			}
+		};
+	}
+
+	@Override
+	public int getCompositeParamCount() {
+		return map.size();
+	}
+
+	@Override
+	public CompositeParam getCompositeParam(int number) {
+		return getParam(number);
 	}
 }
Index: /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 98)
@@ -6,7 +6,7 @@
 import com.framsticks.params.ReassignResult;
 import com.framsticks.params.UniqueListAccess;
+import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
 
-import java.util.HashMap;
 import java.util.Map;
 
@@ -54,8 +54,6 @@
 			information about it's elements is available, which would break resolution flow
 			*/
-			if (oldValue != null) {
-				return new ReassignResult<Map<?,?>>((Map<?,?>) oldValue);
-			}
-			return ReassignResult.create(new HashMap<Object, Object>());
+			return new ReassignResult<Map<?,?>>(Casting.tryCast(Map.class, oldValue));
+			// return ReassignResult.create(new TreeMap<Object, Object>());
 		}
 
Index: /java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 98)
@@ -7,5 +7,4 @@
 import java.text.ParseException;
 import java.util.ArrayList;
-import java.util.Collection;
 import java.util.List;
 
@@ -176,10 +175,15 @@
 		List<Exception> exceptions = new ArrayList<Exception>();
 
-		Collection<Param> paramsC = access.getParams();
-		Param[] params = paramsC.toArray(new Param[] {null});
+		List<Param> paramsL = new ArrayList<>();
+
+		for (Param param : access.getParams()) {
+			paramsL.add(param);
+		}
+
+		Param[] params = paramsL.toArray(new Param[] {null});
 		if (params.length == 0) {
 			return exceptions;
 		}
-		for (PrimitiveParam<?> p : Containers.filterInstanceof(paramsC, PrimitiveParam.class)) {
+		for (PrimitiveParam<?> p : Containers.filterInstanceof(paramsL, PrimitiveParam.class)) {
 			Object def = p.getDef(Object.class);
 			if (def != null) {
